[manpage_begin tcllux::chan n 1.0]
[require   Tcl 8.6]
[require   tcllux::chan [opt 1.0]]
[moddesc   {tcllux::chan}]
[titledesc {TclLux chan}]
[category  {UNIX}]
[copyright {2018 Stuart Cassoff <stwo@users.sourceforge.net>}]
[keywords  unix chan]
[see_also  fcntl(2) sync(2) fsync(2)]

[description]

	The TclLux chan Tcl extension provides
	chan functionality.

[section COMMANDS]

[usage namespace import ::tcllux::lux]

[list_begin definitions]

	[call [cmd {lux chan configure}] [arg channelId] [opt [arg name]] [opt [arg val]] [opt [arg ...]]]
		Configures the [arg channelId].
		Options are -closeonexec and -handle.
		Returns an empty string when setting.

	[call [cmd {lux chan sync}]]
		System sync.
		Returns an empty string.

	[call [cmd {lux chan fsync}] [arg channelId]]
		Syncs the [arg channelId].
		Returns an empty string.

	[call [cmd {lux chan fdatasync}] [arg channelId]]
		Datasyncs the [arg channelId].
		Returns an empty string.

	[call [cmd {lux chan dup}] [arg channelId]]
		Duplicates the [arg channelId] to a new channelId.
		Returns the new channelId.

	[call [cmd {lux chan lock}] [arg channelId] [opt [arg name]] [opt [arg val]] [opt [arg ...]]]
		Locks a region of a file.
		Options and their defaults: -shared true -start 0 -length 0 -origin start -blocking false.
		This command accepts but ignores a -pidvar option.
		Returns a boolean true if the locking was successful, false otherwise.

	[call [cmd {lux chan unlock}] [arg channelId] [opt [arg name]] [opt [arg val]] [opt [arg ...]]]
		Unlocks a region of a file.
		Options and their defaults: -shared true -start 0 -length 0 -origin start -blocking false.
		This command accepts but ignores a -pidvar option.
		Returns a boolean true if the unlocking was successful, false otherwise.

	[call [cmd {lux chan canlock}] [arg channelId] [opt [arg name]] [opt [arg val]] [opt [arg ...]]]
		Checks if region of a file can be locked.
		Options and their defaults: -shared true -start 0 -length 0 -origin start.
		This command accepts but ignores a -blocking option.
		This command accepts a -pidvar option: -pidvar varname.
		If the region can't be locked and the -pidvar option is supplied,
		the pid of the process holding the lock will be stored in
		the variable specified by varname.
		Returns a boolean true if the region can be locked, false otherwise.

	[call [cmd {lux chan owner}] [arg channelId] [opt [arg owner]]]
		Get or set the owner of a channelId.
		Returns an empty string when setting.

	[call [cmd {lux chan write}] [arg channelId] [arg data]]
		Writes [arg data] to [arg channelId].
		Returns the number of bytes written to [arg channelId].

[list_end]

[manpage_end]
